﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;
using System.Collections;
using C1.Util;

namespace SortGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // populate grid.

            Random rnd = new Random();
            c1FlexGrid1.Rows.Count = 21;
            c1FlexGrid1[0, 1] = "Customer Name";
            c1FlexGrid1[0, 2] = "Garment Type";
            c1FlexGrid1[0, 3] = "Size";
            c1FlexGrid1[0, 4] = "Quantity";
            c1FlexGrid1[0, 5] = "Total Price";
            c1FlexGrid1.Cols.Count = 6;
            for (int r = 1; r < c1FlexGrid1.Rows.Count-1; r++)
            {
               
                c1FlexGrid1[r, 2] = (r < 6) ? "T-Shirt" : (r < 10) ? "Shirt" : (r < 14) ? "Jacket" : (r < 18) ? "Blazer" : "Over Coat";                
                for (int c = 4; c <= 4; c++)
                {
                    c1FlexGrid1[r, c] = rnd.Next(1, 10);
                }
                for (int c = 5; c <= 5; c++)
                {
                    c1FlexGrid1[r, c] = rnd.Next(Convert.ToInt32(c1FlexGrid1[r, c])*200, 5000);
                }
            }
            c1FlexGrid1[1, 1] = "John";
            c1FlexGrid1[2, 1] = "Leonardo";
            c1FlexGrid1[3, 1] = "Tom";
            c1FlexGrid1[4, 1] = "Arnold";
            c1FlexGrid1[5, 1] = "Jim";
            c1FlexGrid1[6, 1] = "Ricky";
            c1FlexGrid1[7, 1] = "Alison";
            c1FlexGrid1[8, 1] = "Andy";
            c1FlexGrid1[9, 1] = "Vin Diesel";
            c1FlexGrid1[10, 1] = "Charles";
            c1FlexGrid1[1, 3] = "XXL";
            c1FlexGrid1[2, 3] = "S";
            c1FlexGrid1[3, 3] = "XL";
            c1FlexGrid1[4, 3] = "M";
            c1FlexGrid1[5, 3] = "L";
            c1FlexGrid1[6, 3] = "XL";
            c1FlexGrid1[7, 3] = "XXL";
            c1FlexGrid1[8, 3] = "L";
            c1FlexGrid1[9, 3] = "S";
            c1FlexGrid1[10, 3] = "XS";

            c1FlexGrid1[11, 1] = "Anne";
            c1FlexGrid1[12, 1] = "Paul";
            c1FlexGrid1[13, 1] = "Duke";
            c1FlexGrid1[14, 1] = "Cameron";
            c1FlexGrid1[15, 1] = "Kim";
            c1FlexGrid1[16, 1] = "Louis";
            c1FlexGrid1[17, 1] = "Lee";
            c1FlexGrid1[18, 1] = "James";
            c1FlexGrid1[19, 1] = "Jackie";
            c1FlexGrid1[20, 1] = "Rocky";
            c1FlexGrid1[11, 3] = "XXL";
            c1FlexGrid1[12, 3] = "S";
            c1FlexGrid1[13, 3] = "XL";
            c1FlexGrid1[14, 3] = "M";
            c1FlexGrid1[15, 3] = "L";
            c1FlexGrid1[16, 3] = "XL";
            c1FlexGrid1[17, 3] = "XXL";
            c1FlexGrid1[18, 3] = "L";
            c1FlexGrid1[19, 3] = "S";
            c1FlexGrid1[20, 3] = "XS";  
            foreach(Column col in c1FlexGrid1.Cols)
            {
                col.TextAlign = TextAlignEnum.CenterCenter;
                col.TextAlignFixed = TextAlignEnum.CenterCenter;
            }
        }

        private void sort_Click(object sender, EventArgs e)
        {
            c1FlexGrid1.Sort(new MyComparer(c1FlexGrid1));      // Perform a custom sort on the grid.
        }        
    }

    public class MyComparer: IComparer
    {
        C1FlexGrid cfg;
        public MyComparer(C1FlexGrid cfg)
        {
            this.cfg = cfg;
        }
        public int Compare(object r1,object r2)
        {
            int cmp = 0;
            string s1 = cfg[((Row)r1).Index, 3].ToString();
            string s2 = cfg[((Row)r2).Index, 3].ToString();            
            if(s1=="XS")
            {
                if (s2 == "XS")                
                    cmp = 0;                
                else
                    cmp = -1;
            }
            else if (s1 == "XXL")
            {
                if (s2 == "XXL")
                    cmp = 0;
                else
                    cmp = 1;
            }
            else if (s1 == "S")
            {
                if (s2 == "XS")
                    cmp = 1;
                else if (s2 == "S")
                    cmp = 0;
                else
                    cmp = -1;
            }
            else if (s1 == "L")
            {
                if (s2 == "XS")
                    cmp = 1;
                else if (s2 == "S")
                    cmp = 1;
                else if (s2 == "M")
                    cmp = 1;
                else if (s2 == "L")
                    cmp = 0;
                else
                    cmp = -1;
            }
            else if (s1 == "M")
            {
                if (s2 == "XS")
                    cmp = 1;
                else if (s2 == "S")
                    cmp = 1;
                else if (s2 == "M")
                    cmp = 0;
                else
                    cmp = -1;
            }
            else if (s1 == "XL")
            {
                if (s2 == "XXL")
                    cmp = -1;                
                else if (s2 == "XL")
                    cmp = 0;
                else
                    cmp = 1;
            }
            return cmp;
        }
    }
}
